<?
/*
 UnDEAD's PHPOP3 library. Some PHP3 functions to do stuff with POP3 servers.
  Currently implemented:

 - int pop3open(hostname,port,username,password). Connects to POP3 host and
  try to login. Returns socket number on success, false on fail.

*/

function pop3getline($pop3sock) {
 return strtok(fgets($pop3sock,8192),"\r\n");
}

function pop3open($hostname,$port,$username,$password,$errno=0) {
 $pop3sock=@fsockopen($hostname,$port);
 if(!$pop3sock) { $errno=-1; return false; }
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") { $errno=-2; fclose($pop3sock); return false; }

 fputs($pop3sock,"USER ".$username."\r\n");
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") { $errno=-3; fclose($pop3sock); return false; }

 fputs($pop3sock,"PASS ".$password."\r\n");
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") { $errno=-4; fclose($pop3sock); return false; }

 return $pop3sock;
}

function pop3list($pop3sock) {
 fputs($pop3sock,"LIST\r\n");
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") return false;
 $list=array(); $items=0;
 $line=pop3getline($pop3sock);
 while(substr($line,0,1)!=".") {
  $item=explode(" ",$line);
  $list[$items][nr]=$item[0];
  $list[$items][size]=(int)$item[1];
  $items++;
  $line=pop3getline($pop3sock);
 }

 return $list;
}

function pop3stat($pop3sock) {
 $stat=array();

 fputs($pop3sock,"STAT\r\n");
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") return false;

 $stats=explode(" ",$line);
 $stat[msgs]=$stats[1];
 $stat[size]=$stats[2];

 return $stat;
}

function pop3contenttype($content) {
 $cctype=explode("/",$content);
 $ctype=array();
 $ctype[type]=$cctype[0];
 $ctype[subtype]=$cctype[1];
 if($ctype[type]=="") $ctype[type]="text";
 if($ctype[subtype]=="") $ctype[subtype]="plain";
 return $ctype;
}

function pop3extractheader($msg) {
 $header=array();

 $msg=explode("\n",$msg);
 $last="";
 for($i=0;$i<count($msg);$i++) {
  $line=$msg[$i];
  if($line=="") return $header;
  if((substr($line,0,1)!="\t")&&(substr($line,0,1)!=" ")) {
   $last=strtok($line,": ");
   $data=strtok("");
   while(substr($data,0,1)==" ")
    $data=substr($data,1);
   $dats=explode(";",$data);
   $header[strtolower($last)]=$dats[0];
   for($j=1;$j<count($dats);$j++) {
    while(substr($dats[$j],0,1)==" ")
     $dats[$j]=substr($dats[$j],1);
    $which=strtok($dats[$j],"=");
    $what=strtok("");
    if($what=="") {
     $what=$which;
     $which=$j;
    }
    if(substr($what,0,1)=="\"") {
     $what=substr($what,1,strlen($what)-2);
    }
    $header[strtolower($last."-".$which)]=$what;
   }
  } else {
   $element=strtok(substr($line,1)," =");
   $data=strtok("");
   $dats=explode("; ",$data);
   if(substr($dats[0],0,1)=="\"") {
    $dats[0]=substr($dats[0],1,strlen($dats[0])-2);
   }
   $header[strtolower($last."-".$element)]=$dats[0];
   for($j=1;$j<count($dats);$j++) {
    $which=strtok($dats[$j],"=");
    $what=strtok("");
    if($what=="") {
     $what=$which;
     $which=$j;
    }
    if(substr($what,0,1)=="\"") {
     $what=substr($what,1,strlen($what)-2);
    }
    $header[strtolower($last."-".$element."-".$which)]=$what;
   }
  }
 }
 return false;
}

function pop3getmessage($pop3sock,$msgnr,$nrlines=-1) {
 $msgs=array();
 $msgs[0]=array();
 $msgs[0][hdr]="";
 $msgs[0][body]="";
 $msgcnt=0;
 if($nrlines==-1) {
  fputs($pop3sock,"RETR $msgnr\r\n");
 } else {
  fputs($pop3sock,"TOP $msgnr $nrlines\r\n");
 }
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") return false;

 $line=pop3getline($pop3sock);
 while(($line!="")&&($line!=".")) {
  $msgs[$msgcnt][hdr].=$line."\n";
  $line=pop3getline($pop3sock);
 }
 if($line==".") return $msgs;
 $hdr=pop3extractheader($msgs[$msgcnt][hdr]);
 $boundary=$hdr["content-type-boundary"];
 $eom=false;

 $line=pop3getline($pop3sock);
 $body=true;
 while($line!=".") {
  if(($body==false)&&($line=="")) {
   $body=true;
   $line=pop3getline($pop3sock);
  }
  if(($boundary!="")&&($line=="--".$boundary)) {
   $msgcnt++;
   $body=false;
   $msgs[$msgcnt]=array();
   $msgs[$msgcnt][hdr]="";
   $msgs[$msgcnt][body]="";
  } else if(($boundary!="")&&($line=="--".$boundary."--")) {
   $eom=true;
  } else if(!$eom) if(!$body) {
   $msgs[$msgcnt][hdr].=$line."\n";
  } else {
   if($msgs[$msgcnt][body]!="") $msgs[$msgcnt][body].="\n";
   $msgs[$msgcnt][body].=$line;
  }

  $line=pop3getline($pop3sock);
 }
 return $msgs;
}

function pop3getheader($pop3sock,$msg) {
 $hdr=pop3getmessage($pop3sock,$msg,0);
 return pop3extractheader($hdr[0][hdr]);
}

function pop3delete($pop3sock,$msgnr) {
 fputs($pop3sock,"DELE $msgnr\r\n");
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") return false;
 return true;
}

function pop3close($pop3sock) {
 fputs($pop3sock,"QUIT\r\n");
 $line=pop3getline($pop3sock);
 if(substr($line,0,1)!="+") return false;
 return true;
}

?>