<?

include "../inc/vampconfig.inc";
include "../inc/phpop3.inc";

if($db_binding=="") include sqlBindings();

function enumVirtDomains() {
 $ret=array();
 $q=db_query(sqlDatabase(),"SELECT username FROM users WHERE isvirtual='virtual';");
 if($q) {
  for($i=0;$i<db_numrows($q);$i++) {
   $a=db_getrow($q,$i);
   $ret[$i]=$a[0];
  }
 }
 return $ret;
}

function getUserConfig($user) {
 $ret=false;

 $q=db_query(sqlDatabase(),"SELECT * FROM users WHERE username='".addslashes($user)."';");
 if($q&&(db_numrows($q)>0)) {
  $ret=db_getrow($q,0);
  for($i=0;$i<sizeof($ret);$i++) {
   $ret[$i]=strtr($ret[$i],"|",":");
  }
 }

 return $ret;
}

function getUserDomain($user) {
 $data=getUserConfig($user);
 if(!$data) return false;
 return $data[2];
}

function getPOP3Server($user) {
 $data=getUserConfig($user);
 if(!$data) return false;
 $pop3x=explode(":",$data[1]);
 $pop3=array();
 $pop3[host]=$pop3x[0];
 if($pop3x[1]) {
  $pop3[port]=$pop3x[1];
 } else {
  $pop3[port]=110;
 }
 return $pop3;
}

function getRemoteUser($user) {
 $data=getUserConfig($user);
 if(!$data) return $user;
 if(!($data[4])) return $user;
 return $data[4];
}

function isVirtual($user) {
 $ex=explode("@",$user);
 if(count($ex)==2) {
  $domain=$ex[1];
 } else {
  return false;
 }
 $data=getUserConfig($domain);
 if(!$data) return false;
 if($data[3]=="virtual") return $data[0];
}

function virtualUser($user) {
 $ex=explode("@",$user);
 if(count($ex)==2) {
  return $ex[0];
 } else {
  return false;
 }
}

function getVirtualUserData($user) {
 $ret=false;
 $domain=isVirtual($user);
 if($domain==false) return $ret;

 $vuser=virtualUser($user);
 if($vuser==false) return $ret;

 $ret=db_query(sqlDatabase(),"SELECT * FROM domains WHERE username='".addslashes($user)."';");
 if($ret&&(db_numrows($ret)>0)) {
  $ret=db_getrow($ret,0);
 }

 return $ret;
}

function verifyPOP3Login($user,$pass) {
 if(($user=="")||($pass=="")) return -3;
 $pop3=getPOP3Server($user);
 if(!$pop3) return -2;
 $pop3_hnd=pop3open($pop3[host],$pop3[port],getRemoteUser($user),$pass);
 if(!$pop3_hnd) return -1;
 pop3close($pop3_hnd);
 return 0;
}

function verifyVirtLogin($user,$pass) {
 $data=getVirtualUserData($user);
 if($data==false) return -2;
 if(md5($pass)!=$data[1]) return -1;
 return 0;
}

function verifyLogin($user,$pass) {
 $virt=isVirtual($user);
 if($virt==false) {
  return verifyPOP3Login($user,$pass);
 } else {
  return verifyVirtLogin($user,$pass);
 }
}

function storeLogin($user,$pass,$exp) {
 SetCookie("uws_user",$user,$exp,"","",0);
 SetCookie("uws_pass",$pass,$exp,"","",0);
}

function clearLogin($user) {
 SetCookie("uws_user","",0,"","",0);
 SetCookie("uws_pass","",0,"","",0);
}

function getUserPref($user,$pref) {
 $res=db_query(sqlDatabase(),"SELECT $pref FROM userprefs WHERE username='".addslashes($user)."';");
 if($res&&(db_numrows($res)>0)) {
  $row=db_getrow($res,0);
  return $row[0];
 } else return false;
}

function getServerPref($pref) {
 $q=db_query(sqlDatabase(),"SELECT vdata FROM serverprefs WHERE vname='".addslashes($pref)."';");
 if($q&&(db_numrows($q)>0)) {
  $r=db_getrow($q,0);
  return $r[0];
 }
 return false;
}

function getNumContacts($user) {
 $res=db_query(sqlDatabase(),"SELECT username FROM contacts WHERE username='".addslashes($user)."';");
 if($res) {
  return db_numrows($res);
 } else return 0;
}

function getContact($user,$nr) {
 $q="SELECT cname,creal,cmail FROM contacts WHERE username='".addslashes($user)."';";
 $res=db_query(sqlDatabase(),$q);
 if($res) {
  $row=db_getrow($res,$nr);
  if($row) {
   $row[0]=substr($row[0],strlen($user)+1);
   return $row;
  }
 }
 return false;
}

function replaceContact($user,$nr,$nick,$real,$email) {
 if($nr>getNumContacts($user)) return false;
 $oldcnt=getContact($user,$nr);
 $q="UPDATE contacts SET cname='".addslashes($user.":".$nick)."',creal='".addslashes($real)."',cmail='".addslashes($email)."' where cname='".addslashes($user.":".$oldcnt[0])."';";
 return db_query(sqlDatabase(),$q);
}

function addContact($user,$nick,$real,$email) {
 $res=db_query(sqlDatabase(),"INSERT INTO contacts VALUES ('".addslashes($user)."','".addslashes($user.":".$nick)."','".addslashes($real)."','".addslashes($email)."');");
 if($res) return true;
 return false;
}

function deleteContact($user,$nr) {
 $ret=false;
 if($nr>getNumContacts($user)) return false;
 $cont=getContact($user,$nr);
 $q="DELETE FROM contacts WHERE cname='".addslashes($user.":".$cont[0])."';";
 $res=db_query(sqlDatabase(),$q);
 if($res) $ret=true;
 return $ret;
}

function getNumSignatures($user) {
 $res=db_query(sqlDatabase(),"SELECT username FROM signatures WHERE username='".addslashes($user)."';");
 if($res) {
  return db_numrows($res);
 } else return 0;
}

function addSignature($user,$signame,$sigtext) {
 $res=db_query(sqlDatabase(),"INSERT INTO signatures VALUES ('".addslashes($user)."','".addslashes($user.":".$signame)."','".addslashes($sigtext)."');");
 if($res) return true;
 return false;
}

function getSignature($user,$nr) {
 $ret=false;
 $res=db_query(sqlDatabase(),"SELECT signame,sigtext FROM signatures WHERE username='".addslashes($user)."';");
 if($res) {
  $row=db_getrow($res,$nr);
  if($row) {
   $row[0]=substr($row[0],strlen($user)+1);
   return $row;
  }
 }
 return false;
}

function deleteSignature($user,$nr) {
 $ret=false;
 if($nr>getNumSignatures($user)) return $ret;
 $sig=getSignature($user,$nr);
 $q="DELETE FROM signatures WHERE signame='".addslashes($user.":".$sig[0])."';";
 $res=db_query(sqlDatabase(),$q);
 if($res) $ret=true;
 return $ret;
}

function replaceSignature($user,$nr,$signame,$sigtext) {
 if($nr>getNumSignatures($user)) return false;
 $oldsig=getSignature($user,$nr);
 $q="UPDATE signatures SET signame='".addslashes($user.":".$signame)."',sigtext='".addslashes($sigtext)."' WHERE signame='".addslashes($user.":".$oldsig[0])."';";
 return db_query(sqlDatabase(),$q);
}

function bareEmail($addr) {
 $add=explode("<",$addr);
 if(!$add[1]) {
  $ad=$addr;
 } else {
  $a=explode(">",$add[1]);
  $ad=$a[0];
 }
 return $ad;
}

function getVMsg($mbox,$user,$msg) {
 $stat=pop3stat($mbox,$msg);
 $nmsgs=$stat[msgs];
 $vmsg=0;
 $disp=false;
 for($i=$nmsgs;($i>0)&&(!$disp);$i--) {
  $hdr=pop3getheader($mbox,$i);
  $to=$hdr["received-for"];
  if($to=="") $to=$hdr[To];
  if(bareEmail($to)==$user) {
   $vmsg++;
   if($vmsg==($msg+1)) {
    $disp=true;
    $zmsg=$i-1;
   }
  }
 }
 if($disp) {
  return $zmsg;
 } else {
  return -1;
 }
}

function paraphrase($body,$ll) {
 if($ll==-1) return $body;
 if($ll==0) $ll=76;
 $body=str_replace(chr(13),"",$body);
 $xbody=explode("\n",$body);
 for($i=0;$i<count($xbody);$i++) {
  $zbody=explode(" ",$xbody[$i]);
  $k=0;
  for($j=0;$j<count($zbody);$j++) {
   $l=$zbody[$j];
   if(($k>0)&&(($k+strlen($l))>$ll)) {
    $nbody.="\n";
    $k=0;
   }
   $nbody.=$l;
   if($j<count($zbody)-1) { $nbody.=" "; $k++; }
   $k=$k+strlen($l);
   if(($k>$ll)&&($j<count($zbody)-1)) {
    $nbody.="\n";
    $k=0;
   }
  }
 if($i<count($xbody)+1) $nbody.="\n";
 }
 return $nbody;
}

function array_terminate($a,$item) {
 for($i=0;$i<$item;$i++) {
  $n[$i]=$a[$i];
 }
 for($i=$item+1;$i<count($a);$i++) {
  $n[$i-1]=$a[$i];
 }
 return $n;
}

function openMail($uws_user,$uws_pass) {
 if(($uws_user!="")&&($uws_pass!="")) {
  $virtual=isVirtual($uws_user);
  if($virtual==false) {
   $pop3=getPOP3Server($uws_user);
   $mbox=pop3open($pop3[host],$pop3[port],getRemoteUser($uws_user),$uws_pass);
  } else {
   $pop3=getPOP3Server($virtual);
   $mbox=pop3open($pop3[host],$pop3[port],getRemoteUser($virtual),getServerPref("virtualpw"));
  }
 } else {
  $mbox=false;
 }
 return $mbox;
}

$vamp_lib_here=true;

?>